/* Logging.c generated by valac 0.9.8, the Vala compiler
 * generated from Logging.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define LOGGING_TYPE_FACILITY (logging_facility_get_type ())

#define LOGGING_TYPE_LEVEL (logging_level_get_type ())

typedef enum  {
	LOGGING_FACILITY_SIGNAL_HANDLERS,
	LOGGING_FACILITY_DEVELOPER_WARNINGS,
	LOGGING_FACILITY_GRAPH,
	LOGGING_FACILITY_LOADING,
	LOGGING_FACILITY_IMPORT,
	LOGGING_FACILITY_SINGLEDECODEBIN
} LoggingFacility;

typedef enum  {
	LOGGING_LEVEL_CRITICAL,
	LOGGING_LEVEL_HIGH,
	LOGGING_LEVEL_MEDIUM,
	LOGGING_LEVEL_LOW,
	LOGGING_LEVEL_INFO,
	LOGGING_LEVEL_VERBOSE
} LoggingLevel;


extern LoggingLevel logging_current_level;
LoggingLevel logging_current_level = LOGGING_LEVEL_HIGH;

GType logging_facility_get_type (void) G_GNUC_CONST;
GType logging_level_get_type (void) G_GNUC_CONST;
void logging_set_logging_level (LoggingLevel new_level);
void logging_emit (GObject* object, LoggingFacility facility, LoggingLevel level, const char* message);

const LoggingLevel LOGGING_active_facility[6] = {LOGGING_LEVEL_CRITICAL, LOGGING_LEVEL_CRITICAL, LOGGING_LEVEL_CRITICAL, LOGGING_LEVEL_CRITICAL, LOGGING_LEVEL_CRITICAL, LOGGING_LEVEL_CRITICAL};
const char* LOGGING_facility_names[6] = {"SIGNAL_HANDLERS", "DEVELOPER_WARNINGS", "GRAPH", "LOADING", "IMPORT", "SINGLEDECODEBIN"};


GType logging_facility_get_type (void) {
	static volatile gsize logging_facility_type_id__volatile = 0;
	if (g_once_init_enter (&logging_facility_type_id__volatile)) {
		static const GEnumValue values[] = {{LOGGING_FACILITY_SIGNAL_HANDLERS, "LOGGING_FACILITY_SIGNAL_HANDLERS", "signal-handlers"}, {LOGGING_FACILITY_DEVELOPER_WARNINGS, "LOGGING_FACILITY_DEVELOPER_WARNINGS", "developer-warnings"}, {LOGGING_FACILITY_GRAPH, "LOGGING_FACILITY_GRAPH", "graph"}, {LOGGING_FACILITY_LOADING, "LOGGING_FACILITY_LOADING", "loading"}, {LOGGING_FACILITY_IMPORT, "LOGGING_FACILITY_IMPORT", "import"}, {LOGGING_FACILITY_SINGLEDECODEBIN, "LOGGING_FACILITY_SINGLEDECODEBIN", "singledecodebin"}, {0, NULL, NULL}};
		GType logging_facility_type_id;
		logging_facility_type_id = g_enum_register_static ("LoggingFacility", values);
		g_once_init_leave (&logging_facility_type_id__volatile, logging_facility_type_id);
	}
	return logging_facility_type_id__volatile;
}


GType logging_level_get_type (void) {
	static volatile gsize logging_level_type_id__volatile = 0;
	if (g_once_init_enter (&logging_level_type_id__volatile)) {
		static const GEnumValue values[] = {{LOGGING_LEVEL_CRITICAL, "LOGGING_LEVEL_CRITICAL", "critical"}, {LOGGING_LEVEL_HIGH, "LOGGING_LEVEL_HIGH", "high"}, {LOGGING_LEVEL_MEDIUM, "LOGGING_LEVEL_MEDIUM", "medium"}, {LOGGING_LEVEL_LOW, "LOGGING_LEVEL_LOW", "low"}, {LOGGING_LEVEL_INFO, "LOGGING_LEVEL_INFO", "info"}, {LOGGING_LEVEL_VERBOSE, "LOGGING_LEVEL_VERBOSE", "verbose"}, {0, NULL, NULL}};
		GType logging_level_type_id;
		logging_level_type_id = g_enum_register_static ("LoggingLevel", values);
		g_once_init_leave (&logging_level_type_id__volatile, logging_level_type_id);
	}
	return logging_level_type_id__volatile;
}


#line 46 "Logging.vala"
void logging_set_logging_level (LoggingLevel new_level) {
#line 79 "Logging.c"
	gboolean _tmp0_ = FALSE;
#line 47 "Logging.vala"
	if (new_level <= LOGGING_LEVEL_VERBOSE) {
#line 47 "Logging.vala"
		_tmp0_ = new_level >= LOGGING_LEVEL_CRITICAL;
#line 85 "Logging.c"
	} else {
#line 47 "Logging.vala"
		_tmp0_ = FALSE;
#line 89 "Logging.c"
	}
#line 47 "Logging.vala"
	if (_tmp0_) {
#line 48 "Logging.vala"
		logging_current_level = new_level;
#line 95 "Logging.c"
	}
}


#line 52 "Logging.vala"
void logging_emit (GObject* object, LoggingFacility facility, LoggingLevel level, const char* message) {
#line 102 "Logging.c"
	gboolean _tmp0_ = FALSE;
#line 52 "Logging.vala"
	g_return_if_fail (G_IS_OBJECT (object));
#line 52 "Logging.vala"
	g_return_if_fail (message != NULL);
#line 53 "Logging.vala"
	if (level <= logging_current_level) {
#line 53 "Logging.vala"
		_tmp0_ = TRUE;
#line 112 "Logging.c"
	} else {
#line 53 "Logging.vala"
		_tmp0_ = level <= LOGGING_active_facility[facility];
#line 116 "Logging.c"
	}
#line 53 "Logging.vala"
	if (_tmp0_) {
#line 54 "Logging.vala"
		fprintf (stderr, "%s(%s): %s\n", g_type_name (G_TYPE_FROM_INSTANCE (object)), LOGGING_facility_names[facility], message);
#line 122 "Logging.c"
	}
}




